VarAdd <- function(infi, outf, namY, namX, NumSims=1000)
{
  d <- read.csv(infi)
  y <- d[namY]
  x <- d[namX]

  cat("File: ", infi, "; Trait: ", namY, "; Locus: ", namX, "\n", file=outf, append=TRUE)
  y <- as.vector(scale(y))

  #library(MASS)
  #library(car)
  #y <- 1/100 + y - min(y)
  #j <- boxcox(y ~ 1, plotit=FALSE); la <- j$x[which.max(j$y)]; y <- box.cox(y,la)

  GetChi <- function(y, x, outf, verb=0) {
    n0 <- length(y[x==0])
    y0 <- y[x==0]
    v0 <- var(y0) * (n0-1)/n0
    m0 <- mean(y0)

    n1 <- length(y[x==1])
    y1 <- y[x==1]
    v1 <- var(y1) * (n1-1)/n1
    m1 <- mean(y1)

    n2 <- length(y[x==2])
    y2 <- y[x==2]
    v2 <- var(y2) * (n2-1)/n2
    m2 <- mean(y2)

    n <- n0+n1+n2

    mA <- (2*sum(y0) + sum(y1)) / (2*n0 + n1)
    ma <- (2*sum(y2) + sum(y1)) / (2*n2 + n1)
    vA <- (2*sum((y0-mA)^2) + sum((y1-mA)^2)) / (2*n0 + n1)
    va <- (2*sum((y2-ma)^2) + sum((y1-ma)^2)) / (2*n2 + n1)
    v <- (2*sum((y0-mA)^2) + sum((y1-mA)^2) + 2*sum((y2-ma)^2) + sum((y1-ma)^2)) / (2*n)

    vfull <- var(y) * (n-1)/n
    mfull <- mean(y)

    l0 <- 2*sum(dnorm(y, mfull, sqrt(vfull), log=TRUE))

    lmv0 <- 2*dnorm(y0, mA, sqrt(vA), log=TRUE)
    lmv1 <- dnorm(y1, mA, sqrt(vA), log=TRUE)+dnorm(y1, ma, sqrt(va), log=TRUE)
    lmv2 <- 2*dnorm(y2, ma, sqrt(va), log=TRUE)
    lmv <- sum(lmv0)+sum(lmv1)+sum(lmv2)

    lm0 <- 2*dnorm(y0, mA, sqrt(v), log=TRUE)
    lm1 <- dnorm(y1, mA, sqrt(v), log=TRUE)+dnorm(y1, ma, sqrt(v), log=TRUE)
    lm2 <- 2*dnorm(y2, ma, sqrt(v), log=TRUE)
    lm <- sum(lm0)+sum(lm1)+sum(lm2)

    x2m <- 2*(lm-l0)
    x2mv <- 2*(lmv-l0)
    x2v <- 2*(lmv-lm)
    if(verb) {
      cat("m_A =", mA, "\n", file=outf,append=TRUE)
      cat("m_a =", ma, "\n", file=outf,append=TRUE)
      cat("V =", v, "\n", file=outf,append=TRUE)
      cat("V_A =", vA, "\n", file=outf,append=TRUE)
      cat("V_a =", va, "\n", file=outf,append=TRUE)
      cat("Additive model; Mean chi-square =", x2m, file=outf,append=TRUE)
      cat("; p-value =", 1-pchisq(x2m,1), "\n", file=outf,append=TRUE)
      cat("Additive model; Mean+Var chi-square =", x2mv, file=outf,append=TRUE)
      cat("; p-value =", 1-pchisq(x2mv,2), "\n", file=outf,append=TRUE)
      cat("Additive model; Var chi-square =", x2v, file=outf,append=TRUE)
      cat("; p-value =", 1-pchisq(x2v,1), "\n", file=outf,append=TRUE)
    }
    return (c(x2m, x2mv, x2v))
  }

  k <- c(0,0,0)
  x0 <- GetChi(y, x, outf, verb=1)
  for(i in 1:NumSims) {
    yj <- sample(y, replace=FALSE)
    xi <- GetChi(yj, x, outf, verb=0)
    k[xi >= x0] <- k[xi >= x0]+1
  }

  pp <- k/NumSims
  cat("Perm p-values:", pp[1], ",", pp[2], ",", pp[3], "\n\n", file=outf,append=TRUE)
}

