# imputation of missing values for genotypes
library(mice)

# input file
d <- read.csv("dat-missing.csv")

# number of imputations
mi <- 100

# ignore the first column, assuming that it contains
# response values
md <- mice(d[,-1], m=mi)

for(i in 1:mi) {
    if(i == 1) {
	gni <- complete(md, i)
    } else {
	gni <- gni + complete(md, i)
    }
}

#take the average of imputed values
gni <- round(gni / mi)

# put back the first (ignored) column
imputed.data <- cbind(d[,1], gni)
names(imputed.data) <- names(d)
write.csv(imputed.data, file="dat-imputed.csv", row.names=FALSE)

