VarRec <- function(infi, outf, namY, namX, NumSims = 1000) 
{
  d <- read.csv(infi)
  y <- d[namY]
  x <- d[namX]

  cat("File: ", infi, "; Trait: ", namY, "; Locus: ", namX, "\n", file=outf, append=TRUE)
  y <- as.vector(scale(y))

  #library(MASS)
  #library(car)
  #y <- 1/100 + y - min(y)
  #j <- boxcox(y ~ 1, plotit=FALSE); la <- j$x[which.max(j$y)]; y <- box.cox(y,la)

  GetChi <- function(y, x, outf, verb=0) {
    n0 <- length(y[x==2 | x==1])
    y0 <- y[x==2 | x==1]
    v0 <- var(y0) * (n0-1)/n0
    m0 <- mean(y0)

    n2 <- length(y[x==0])
    y2 <- y[x==0]
    v2 <- var(y2) * (n2-1)/n2
    m2 <- mean(y2)

    n <- n0+n2
    v <- (v0*n0 + v2*n2) / n

    lmv0 <- dnorm(y0, m0, sqrt(v0), log=TRUE)
    lmv2 <- dnorm(y2, m2, sqrt(v2), log=TRUE)
    lmv <- sum(lmv0)+sum(lmv2)
    lm0 <- dnorm(y0, m0, sqrt(v), log=TRUE)
    lm2 <- dnorm(y2, m2, sqrt(v), log=TRUE)
    lm <- sum(lm0)+sum(lm2)
    vfull <- var(y) * (n-1)/n
    mfull <- mean(y)
    l0 <- sum(dnorm(y, mfull, sqrt(vfull), log=TRUE))
    x2m <- 2*(lm-l0)
    x2mv <- 2*(lmv-l0)
    x2v <- 2*(lmv-lm)
    if(verb) {
      cat("QTL mean with no target haplotype =", m2, "\n", file=outf,append=TRUE)
      cat("QTL mean with 1 or 2 target haplotypes =", m0, "\n", file=outf,append=TRUE)
      cat("QTL standard dev =", sqrt(v), "\n", file=outf,append=TRUE)
      cat("QTL standard dev with no target haplotype =", sqrt(v2), "\n", file=outf,append=TRUE)
      cat("QTL standard dev with 1 or 2 target haplotypes =", sqrt(v0), "\n", file=outf,append=TRUE)
      cat("Recessive model; Mean chi-square =", x2m, file=outf,append=TRUE)
      cat("; p-value =", 1-pchisq(x2m,1), "\n", file=outf,append=TRUE)
      cat("Recessive model; Mean+Var chi-square =", x2mv, file=outf,append=TRUE)
      cat("; p-value =", 1-pchisq(x2mv,2), "\n", file=outf,append=TRUE)
      cat("Recessive model; Var chi-square =", x2v, file=outf,append=TRUE)
      cat("; p-value =", 1-pchisq(x2v,1), "\n", file=outf,append=TRUE)
    }
    return (c(x2m, x2mv, x2v))
  }

  k <- c(0,0,0)
  x0 <- GetChi(y, x, outf, verb=1)
  for(i in 1:NumSims) {
    yj <- sample(y, replace=FALSE)
    xi <- GetChi(yj, x, outf, verb=0)
    k[xi >= x0] <- k[xi >= x0]+1
  }

  pp <- k/NumSims
  cat("Perm p-values:", pp[1], ",", pp[2], ",", pp[3], "\n\n", file=outf,append=TRUE)
}
